unit U_finishSalesConInput;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, cxStyles, cxCustomData, cxGraphics, cxFilter, cxData, cxDataStorage,
  cxEdit, DB, cxDBData, cxGridLevel, cxGridCustomTableView, cxGridTableView,
  cxGridDBTableView, cxClasses, cxControls, cxGridCustomView, cxGrid, cxMemo,
  cxRichEdit, ComCtrls, cxContainer, cxTextEdit, cxMaskEdit, cxButtonEdit,
  StdCtrls, ToolWin, DBClient, ADODB, ExtCtrls, BtnEdit, cxCalendar, StrUtils,
  cxDropDownEdit, cxGridCustomPopupMenu, cxGridPopupMenu, cxLookAndFeels,
  cxLookAndFeelPainters, dxSkinsCore, dxSkinsDefaultPainters, cxNavigator,
  dxDateRanges, dxBarBuiltInMenu, dxDateTimeWheelPicker, dxGDIPlusClasses,
  Vcl.Menus, MovePanel, cxCheckBox, cxImage, cxDBEdit, Vcl.DBCtrls, U_BaseInput,
  System.ImageList, Vcl.ImgList, IdBaseComponent, IdComponent, IdTCPConnection,
  IdTCPClient, IdExplicitTLSClientServerBase, IdFTP, ShellAPI,
  dxSkinOffice2013White, dxSkinSharpPlus, dxSkinWXI, dxScrollbarAnnotations,
  dxCore, cxDateUtils, cxImageList, cxCurrencyEdit;

type
  TfrmfinishSalesConInput = class(TfrmBaseInput)
    ToolBar1: TToolBar;
    TBSave: TToolButton;
    TBClose: TToolButton;
    ScrollBox1: TScrollBox;
    Label3: TLabel;
    ToolBar2: TToolBar;
    ToolButton1: TToolButton;
    ToolButton2: TToolButton;
    cxGrid1: TcxGrid;
    Tv1: TcxGridDBTableView;
    cxGrid1Level1: TcxGridLevel;
    ADOTemp: TADOQuery;
    ADOCmd: TADOQuery;
    DS_1: TDataSource;
    Order_Sub: TClientDataSet;
    v1PRTOrderQty: TcxGridDBColumn;
    Label10: TLabel;
    ConNo: TcxTextEdit;
    Label14: TLabel;
    v1XHNo: TcxGridDBColumn;
    v1OrderUnit: TcxGridDBColumn;
    Label6: TLabel;
    v1Column4: TcxGridDBColumn;
    v1Column5: TcxGridDBColumn;
    v1Column6: TcxGridDBColumn;
    VC_SCSCode: TcxGridDBColumn;
    cxgrdpmn1: TcxGridPopupMenu;
    v1Column1: TcxGridDBColumn;
    pm_sub: TPopupMenu;
    N1: TMenuItem;
    Tv1Column7: TcxGridDBColumn;
    DataSource1: TDataSource;
    ADOQueryImage: TADOQuery;
    DS_ImgHX: TDataSource;
    Qry_ImgHX: TADOQuery;
    IdFTP1: TIdFTP;
    Label15: TLabel;
    Label16: TLabel;
    PackSeal: TBtnEditC;
    Label17: TLabel;
    N2: TMenuItem;
    DlyNote: TcxTextEdit;
    ToolButton3: TToolButton;
    lblSalesId: TLabel;
    Label25: TLabel;
    SalesId: TcxTextEdit;
    TallyId: TcxTextEdit;
    BuyName: TcxButtonEdit;
    QtyNote: TcxButtonEdit;
    ConDate: TcxDateEdit;
    ToolButton4: TToolButton;
    Label1: TLabel;
    DlyDate: TcxDateEdit;
    Tv1density: TcxGridDBColumn;
    Tv1C_WidthUnit: TcxGridDBColumn;
    Tv1ShaZhi: TcxGridDBColumn;
    Tv1C_Color: TcxGridDBColumn;
    Tv1SampleTime: TcxGridDBColumn;
    Tv1ConPrice: TcxGridDBColumn;
    Tv1Currency: TcxGridDBColumn;
    Tv1ConTotalAmount: TcxGridDBColumn;
    Tv1C_GramWeight: TcxGridDBColumn;
    InspScore: TcxTextEdit;
    InspStandard: TcxButtonEdit;
    Label2: TLabel;
    Label4: TLabel;
    procedure TBCloseClick(Sender: TObject);
    procedure FormShow(Sender: TObject);

    procedure N1Click(Sender: TObject);
    procedure Pic_Image1DblClick(Sender: TObject);

    procedure N2Click(Sender: TObject);
    procedure ToolButton1Click(Sender: TObject);
    procedure ToolButton2Click(Sender: TObject);
    procedure ToolButton4Click(Sender: TObject);
    procedure TBSaveClick(Sender: TObject);
    procedure BuyNamePropertiesButtonClick(Sender: TObject; AButtonIndex: Integer);
    procedure v1OrderUnitPropertiesButtonClick(Sender: TObject;
      AButtonIndex: Integer);
    procedure InspStandardPropertiesButtonClick(Sender: TObject;
      AButtonIndex: Integer);
  private
    FLeft, FTop: Integer;
    fuserName, Fstatus: string;
    procedure JSMoney();
    procedure InitData();
    function TestData(): Boolean;
    function SaveData(): Boolean;
    procedure SetXH();
    procedure LookImage(FileName: string);
    { Private declarations }
  public
    CopyInt: Integer;
    PState: string;
    fFlileFlag: string;
    FConMId: string;
    FAuthority, FGSTT: string;
    { Public declarations }
  end;

var
  frmfinishSalesConInput: TfrmfinishSalesConInput;
  newh: hwnd;

implementation

uses
  U_DataLink, U_RTFun, U_ZDYHelp, U_CompanySel, U_ClothInfoSel,
  U_PictureUpload11, U_TatClothInfoSel, U_BankSel;

{$R *.dfm}

procedure TfrmfinishSalesConInput.SetXH();
var
  i: Integer;
begin
  with Order_Sub do
  begin
    First;
    i := 1;
    while not Eof do
    begin
      with Order_Sub do
      begin
        Edit;
        FieldByName('XHNoTemp').Value := i;
        Post;
      end;
      i := i + 1;
      Next;
    end;
  end;

  with Order_Sub do
  begin
    Order_Sub.IndexFieldNames := '';
    First;
    i := 1;
    while not Eof do
    begin
      with Order_Sub do
      begin
        Edit;
        FieldByName('SerialNo').Value := FieldByName('XHNoTemp').AsInteger;
        Post;
      end;
      i := i + 1;
      Next;
    end;
    Order_Sub.IndexFieldNames := 'SerialNo';
  end;

end;

procedure TfrmfinishSalesConInput.JSMoney();
var
  FConQty, FConPrice, FC_Money: Double;
begin
  with Order_Sub do
  begin
    FConQty := Fieldbyname('ConQty').AsFloat;
    FConPrice := Fieldbyname('ConPrice').AsFloat;
  end;
  //计算金额，保留2位小数
  FC_Money := RoundFloat(FConQty * FConPrice, 2);
  with Order_Sub do
  begin
    Edit;
    FieldByName('ConTotalAmount').Value := FC_Money;
    Post;
  end;
  tv1.Controller.EditingController.ShowEdit();
end;

function TfrmfinishSalesConInput.TestData(): Boolean;
begin
  try
    if Trim(ConNo.Text) = '' then
      raise Exception.Create('合同号不能为空！');

    if Order_Sub.Locate('C_Code', null, []) then
      raise Exception.Create('产品编号不能为空！');
    if Order_Sub.Locate('C_Code', '', []) then
      raise Exception.Create('产品编号不能为空！');
    if Order_Sub.Locate('C_Name', null, []) then
      raise Exception.Create('品名不能为空！');
    if Order_Sub.Locate('C_Name', '', []) then
      raise Exception.Create('品名不能为空！');
//    if Order_Sub.Locate('C_Color', null, []) then
//      raise Exception.Create('颜色不能为空！');
//    if Order_Sub.Locate('C_Color', '', []) then
//      raise Exception.Create('颜色不能为空！');


//    if Order_Sub.Locate('C_MF', null, []) then
//      raise Exception.Create('门幅不能为空！');
//    if Order_Sub.Locate('C_MF', '', []) then
//      raise Exception.Create('门幅不能为空！');
//    if Order_Sub.Locate('C_KZ', null, []) then
//      raise Exception.Create('克重不能为空！');
//    if Order_Sub.Locate('C_KZ', '', []) then
//      raise Exception.Create('克重不能为空！');
    if Order_Sub.Locate('ConQty', null, []) then
      raise Exception.Create('数量不能为空！');
    if Order_Sub.Locate('ConQty', 0, []) then
      raise Exception.Create('数量不能为0！');
    if Order_Sub.Locate('ConUnit', null, []) then
      raise Exception.Create('数量单位不能为空！');
    if Order_Sub.Locate('ConUnit', '', []) then
      raise Exception.Create('数量单位不能为空！');
    Result := True;
  except
    Result := false;
    application.MessageBox(PChar(Exception(ExceptObject).Message), '提示信息', 0);
  end;
end;

procedure TfrmfinishSalesConInput.ToolButton1Click(Sender: TObject);  //增行
var
  i: Integer;
  maxno: string;
begin
  if GetLSNo(ADOCmd, maxno, 'CPCS', 'CP_Contract_Sub', 4, 1) = False then
  begin
    ADOCmd.Connection.RollbackTrans;
    Application.MessageBox('取子流水号失败！', '提示', 0);
    Exit;
  end;
  if Trim(ConNo.Text) = '' then
  begin
    Application.MessageBox('合同号不能为空!', '提示', 0);
    Exit;
  end;
  i := Order_Sub.RecordCount;      //当前的dataset有多少行记录
  i := i + 1;
  CopyAddRow(Tv1, Order_Sub);
  with Order_Sub do
  begin
    Edit;
    FieldByName('SSEL').Value := FALSE;
    FieldByName('SerialNo').Value := i;
    FieldByName('ConSId').Value := maxno;
    FieldByName('ConQty').Value := null;
    FieldByName('ConUnit').Value := 'M';
    Post;
  end;
  SetXH();
end;

procedure TfrmfinishSalesConInput.ToolButton2Click(Sender: TObject);
begin
  if Order_Sub.IsEmpty then
    Exit;
  if Application.MessageBox('确定要删除数据吗？', '提示', 32 + 4) <> IDYES then
    Exit;
  while Order_Sub.Locate('SSel', True, []) do
  begin
    with ADOTemp do
    begin
      Close;
      sql.Clear;
      sql.Add('select * from  Trade_Plan_Sub where ConSId=''' + Trim(Order_Sub.fieldbyname('ConSId').AsString) + '''');
      open;
    end;
    if ADOTemp.IsEmpty = false then
    begin
      exit;
      application.MessageBox('该明细已经在生产！', '提示信息');
    end;
    if Trim(Order_Sub.fieldbyname('ConSId').AsString) <> '' then
    begin
      with ADOCmd do
      begin
        Close;
        sql.Clear;
        sql.Add('delete CP_Contract_Sub where ConSId=''' + Trim(Order_Sub.fieldbyname('ConSId').AsString) + '''');
        ExecSQL;
      end;
    end;
    Order_Sub.Delete;
  end;
  SetXH();
end;

procedure TfrmfinishSalesConInput.ToolButton4Click(Sender: TObject);
var
  i: Integer;
  maxno: string;
  MCYNo: string;
begin

  if Trim(ConNo.Text) = '' then
  begin
    Application.MessageBox('合同号不能为空!', '提示', 0);
    Exit;
  end;

  i := Order_Sub.RecordCount;      //当前的dataset有多少行记录


  frmTatClothInfoSel := TfrmTatClothInfoSel.Create(self);
  with frmTatClothInfoSel do
  begin
    if showmodal = 1 then
    begin

      with CDS_1 do
      begin
        DisableControls;
        First;
        while not eof do
        begin
          if CDS_1.fieldbyname('SSel').AsBoolean then
          begin

            if GetLSNo(ADOCmd, maxno, 'CPCS', 'CP_Contract_Sub', 4, 1) = False then
            begin
              ADOCmd.Connection.RollbackTrans;
              Application.MessageBox('取子流水号失败！', '提示', 0);
              Exit;
            end;

            with Self.Order_Sub do
            begin
              append;

              Order_Sub.fieldbyname('C_Code').Value := frmTatClothInfoSel.CDS_1.fieldbyname('C_Code').asstring;
              Order_Sub.fieldbyname('C_Name').Value := frmTatClothInfoSel.CDS_1.fieldbyname('C_Name').asstring;

              Order_Sub.fieldbyname('C_Spec').Value := frmTatClothInfoSel.CDS_1.fieldbyname('C_Spec').asstring;
              Order_Sub.fieldbyname('C_Composition').Value := frmTatClothInfoSel.CDS_1.fieldbyname('C_Composition').asstring;

              Order_Sub.fieldbyname('C_Width').Value := frmTatClothInfoSel.CDS_1.fieldbyname('C_Width').asstring;
//              Order_Sub.fieldbyname('BBNO').Value := frmTatClothInfoSel.CDS_1.fieldbyname('BBNO').asstring;

              FieldByName('SSEL').Value := FALSE;
              FieldByName('SerialNo').Value := i;
              FieldByName('ConSId').Value := maxno;
              FieldByName('ConQty').Value := null;
//              FieldByName('ConTotalAmount').Value := null;
              FieldByName('ConUnit').Value := 'M';
            end;
          end;
          Next;
          i := i + 1;
        end;
        EnableControls;
      end;

    end;
    free;
  end;

  tv1.Controller.EditingController.ShowEdit();
  SetXH();
end;

procedure TfrmfinishSalesConInput.v1OrderUnitPropertiesButtonClick(
  Sender: TObject; AButtonIndex: Integer);
begin

  try
    frmZDYHelp := TfrmZDYHelp.Create(Application);
    with frmZDYHelp do
    begin
      MainType := 'ConUnit';
      if ShowModal = 1 then
      begin
        TcxButtonEdit(Sender).Text := Trim(ClientDataSet1.fieldbyname('ZDYName').AsString);
      end;
    end;
  finally
    frmZDYHelp.Free;
  end;
end;

procedure TfrmfinishSalesConInput.TBCloseClick(Sender: TObject);
begin

  Close;
end;

procedure TfrmfinishSalesConInput.TBSaveClick(Sender: TObject);
begin
  ConDate.SetFocus;

  if TestData() = false then
    exit;

  if SaveData() then
  begin
    Application.MessageBox('保存成功！', '提示', 0);
  end;
end;

procedure TfrmfinishSalesConInput.InitData();
var
  maxno: string;
begin
  //刷新产品信息
  with ADOTemp do
  begin
    Close;
    SQL.Clear;
    sql.Add(' select * from CP_Contract_Sub ');
    sql.Add('where ConMId=''' + Trim(FConMId) + '''');
    sql.Add(' order by SerialNo ');
    Open;
  end;
  SCreateCDS(ADOTemp, Order_Sub);
  SInitCDSData(ADOTemp, Order_Sub);
   //刷新条款信息
  with ADOTemp do
  begin
    Close;
    sql.Clear;
    sql.Add('select * from CP_Contract_Main where ConMId=''' + Trim(FConMId) + '''');
    Open;
  end;
  SCSHData(ADOTemp, ScrollBox1, 2);

  BuyName.Properties.LookupItems.Text := Trim(ADOTemp.FieldByName('BuyNo').AsString);

  Fstatus := Trim(ADOTemp.FieldByName('status').AsString);

  if PState = '新增' then
  begin
    ConDate.Date := SGetServerDateTime(ADOTemp);
    DlyDate.Date := ConDate.Date;
    ConNo.Text := '自动生成';

    SalesID.Text := trim(DCode);
  end;

  if PState = '复制' then
  begin

    PState := '新增';
    FConMId := '';
    ConNo.Text := '自动生成';

    with Order_Sub do
    begin
      First;
      while not Eof do
      begin
        if GetLSNo(ADOCmd, maxno, 'CPSCS', 'CP_Contract_Sub', 4, 1) = False then
        begin
          Application.MessageBox('取子流水号失败！', '提示', 0);
          Exit;
        end;
        Edit;
        FieldByName('ConMId').Value := '';
        FieldByName('ConSId').Value := maxno;
        Post;
        Next;
      end;
    end;
  end;

end;

procedure TfrmfinishSalesConInput.InspStandardPropertiesButtonClick(
  Sender: TObject; AButtonIndex: Integer);
var
  fsj: string;
  FWZ: Integer;
begin
  fsj := Trim(TcxButtonEdit(Sender).Hint);
  FWZ := Pos('/', fsj);
  try
    frmZDYHelp := TfrmZDYHelp.Create(Application);
    with frmZDYHelp do
    begin
      MainType := Copy(fsj, FWZ + 1, Length(fsj) - FWZ);
      flag := Copy(fsj, 1, FWZ - 1);
      flagname := Copy(fsj, FWZ + 1, Length(fsj) - FWZ);
      if ShowModal = 1 then
      begin
        TcxButtonEdit(Sender).Text := Trim(ClientDataSet1.fieldbyname('ZDYName').AsString);
      end;
    end;
  finally
    frmZDYHelp.Free;
  end;
end;

procedure TfrmfinishSalesConInput.N1Click(Sender: TObject);
var
  FValue, FFValue, FColumn, FFColumn, MHXSID: string;
  MXHNO: Integer;
begin
  if Fstatus = '1' then
  begin
    application.MessageBox('合同已审核，无法操作！', '提示信息', 0);
    exit;
  end;
  MXHNO := Order_Sub.FieldByName('XHNo').ASInteger;
  FColumn := Tv1.Controller.FocusedColumn.DataBinding.FilterFieldName;
  FValue := Trim(Order_Sub.fieldbyname(FColumn).AsString);
  MHXSID := Trim(Order_Sub.fieldbyname('HXSID').AsString);
  with Order_Sub do
  begin
    DisableControls;
    First;
    while not Eof do
    begin
      if FieldByName('SSel').AsBoolean then
      begin
        Edit;

        if FValue = '' then
        begin
          Order_Sub.FieldByName(FColumn).Value := null;
        end
        else
        begin
          Order_Sub.FieldByName(FColumn).Value := FValue;
        end;
        if FColumn = 'C_HX' then
        begin
          Order_Sub.FieldByName('HXSID').Value := MHXSID;
        end;
        Post;
        JSMoney();
      end;
      Next;
    end;
    EnableControls;
  end;
  Order_Sub.Locate('XHNO', MXHNO, []);
end;

procedure TfrmfinishSalesConInput.N2Click(Sender: TObject);
var
  FValue, MC_Code, MC_Craft, MC_Name, MC_Spec, MC_CF, MC_Color, MC_MF, MC_KZ, MC_Note, MC_Unit, MGcHuaNo, MSuoLv, MC_EName: string;
  MXHNO: Integer;
begin
  if Fstatus = '1' then
  begin
    application.MessageBox('合同已审核，无法操作！', '提示信息', 0);
    exit;
  end;

  MXHNO := Order_Sub.FieldByName('XHNo').ASInteger;
  MC_Code := Order_Sub.fieldbyname('C_Code').AsString;
  MC_Craft := Order_Sub.fieldbyname('C_Craft').AsString;
  MC_Name := Order_Sub.fieldbyname('C_Name').AsString;
  MC_Spec := Order_Sub.fieldbyname('C_Spec').AsString;
  MC_CF := Order_Sub.fieldbyname('C_CF').AsString;
  MC_Color := Order_Sub.fieldbyname('C_Color').AsString;
  MC_MF := Order_Sub.fieldbyname('C_MF').AsString;
  MC_KZ := Order_Sub.fieldbyname('C_KZ').AsString;
  MC_Note := Order_Sub.fieldbyname('C_Note').AsString;
  MC_Unit := Order_Sub.fieldbyname('C_Unit').AsString;
  MSuoLv := Order_Sub.fieldbyname('SuoLv').AsString;
  MGcHuaNo := Order_Sub.fieldbyname('GcHuaNo').AsString;
  MC_EName := Order_Sub.fieldbyname('C_EName').AsString;

  with Order_Sub do
  begin
    DisableControls;
    First;
    while not Eof do
    begin
      if FieldByName('SSel').AsBoolean then
      begin
        Edit;
        Order_Sub.fieldbyname('C_Code').Value := MC_Code;
        Order_Sub.fieldbyname('C_Craft').Value := MC_Craft;
        Order_Sub.fieldbyname('C_Name').Value := MC_Name;
        Order_Sub.fieldbyname('C_Spec').Value := MC_Spec;
        Order_Sub.fieldbyname('C_CF').Value := MC_CF;
        Order_Sub.fieldbyname('C_Color').Value := MC_Color;
        Order_Sub.fieldbyname('C_MF').Value := MC_MF;
        Order_Sub.fieldbyname('C_KZ').Value := MC_KZ;
        Order_Sub.fieldbyname('C_Note').Value := MC_Note;
        Order_Sub.fieldbyname('C_Unit').Value := MC_Unit;
        Order_Sub.fieldbyname('SuoLv').Value := MSuoLv;
        Order_Sub.fieldbyname('GcHuaNo').Value := MGcHuaNo;
        Order_Sub.fieldbyname('C_EName').Value := MC_EName;
        Post;

      end;
      Next;
    end;
    EnableControls;
  end;
  Order_Sub.Locate('XHNO', MXHNO, []);
end;

procedure TfrmfinishSalesConInput.Pic_Image1DblClick(Sender: TObject);
begin
  if TcxDBImage(Sender).Picture.Height = 0 then
    exit;

  LookImage(ADOQueryImage.fieldbyname(TcxDBImage(Sender).Hint).asstring);
end;

procedure TfrmfinishSalesConInput.LookImage(FileName: string);
var
  sFieldName: string;
begin
  sFieldName := leftbstr(ExtractFilePath(Application.ExeName), 1) + ':\图片查看';
  if not DirectoryExists(pchar(sFieldName)) then
    CreateDirectory(pchar(sFieldName), nil);
  sFieldName := sFieldName + '\' + trim(FileName);
  try
    IdFTP1.Host := ReadINIFileStr('SYSTEMSET.INI', 'SERVER', '服务器地址', '127.0.0.1');
    IdFTP1.Username := 'three';
    IdFTP1.Password := '641010';
    IdFTP1.Connect();
  except
    ;
  end;

  if IdFTP1.Connected then
  begin
    try
      IdFTP1.Get(fFlileFlag + '\' + Trim(FileName), sFieldName, true, false);
    except
      Application.MessageBox('客户图样文件不存在', '提示', MB_ICONWARNING);
      IdFTP1.Quit;
      Exit;
    end;
  end
  else
  begin
    Application.MessageBox('无法连接文件服务器', '提示', MB_ICONWARNING);
    IdFTP1.Quit;
    Exit;
  end;
  if IdFTP1.Connected then
    IdFTP1.Quit;
  ShellExecute(Handle, 'open', PChar(sFieldName), '', '', SW_SHOWNORMAL);
end;

procedure TfrmfinishSalesConInput.BuyNamePropertiesButtonClick(Sender: TObject; AButtonIndex: Integer);
begin
  try
    frmCompanySel := TfrmCompanySel.Create(Application);
    with frmCompanySel do
    begin
      FCoType := '客户';
      if Self.FAuthority = '录入' then
        FAuthority := '理单业务';
      if ShowModal = 1 then
      begin
        self.BuyName.Properties.LookupItems.Text := Trim(frmCompanySel.CDS_1.fieldbyname('CoCode').AsString);
        self.BuyName.Text := Trim(frmCompanySel.CDS_1.fieldbyname('CoAbbrName').AsString);
//        self.SalesId.Text := Trim(frmCompanySel.CDS_1.fieldbyname('SalesId').AsString);
//        self.Saleser.Text := Trim(frmCompanySel.CDS_1.fieldbyname('Saleser').AsString);
        self.TallyId.Text := Trim(frmCompanySel.CDS_1.fieldbyname('TallyId').AsString);
      end;
    end;

  finally
    frmCompanySel.Free;
  end;
end;

procedure TfrmfinishSalesConInput.FormShow(Sender: TObject);
begin
  inherited;
  readCxGrid(trim(self.Caption), Tv1, '销售合同管理');
  fFlileFlag := UserDataFlag + 'HX';
  InitData();
end;

function TfrmfinishSalesConInput.SaveData(): Boolean;
var
  maxno, ZiMu: string;
  fconNO, fmxType, fDate, YueRi: string;
begin
  try
    ADOCmd.Connection.BeginTrans;
////////////////       保存主表          //////////////////////
    if Trim(FConMId) = '' then
    begin
      if GetLSNo(ADOTemp, maxno, 'CPCM', 'CP_Contract_Main', 3, 1) = False then
        raise Exception.Create('取最大号失败！');

      fDate := FormatDateTime('yy', SGetServerDate(ADOTemp));
      YueRi := FormatDateTime('MMDD', SGetServerDate(ADOTemp));

      if trim(ConNo.Text) = '自动生成' then
      begin

        with ADOTemp do
        begin
          Close;
          sql.Clear;
          SQL.Add('select ZiMu = dbo.GetPinYin(''' + Trim(BuyName.text) + ''')');
          Open;
        end;
        ZiMu := Trim(ADOTemp.fieldbyname('ZiMu').AsString);

        if GetLSNo(ADOTemp, fconNO, fDate, 'CP_Contract_Main', 4, 0) = False then
          raise Exception.Create('取最合同编号失败！');
//
////        fconNO := Copy(fconNO, 1, 4) + YueRi + Copy(fconNO, 5, 4);
//        if ConType.Text = '内销' then
//          fconNO := 'N' + fconNO
//        else
//          fconNO := 'W' + fconNO;
        ConNo.Text := fconNO;
      end;
    end
    else
    begin
      maxno := Trim(FConMId);
    end;
    with ADOCmd do
    begin
      Close;
      sql.Clear;
      SQL.Add('select * from CP_Contract_Main where ConMId=''' + Trim(FConMId) + '''');
      Open;
    end;
    with ADOCmd do
    begin
      if Trim(FConMId) = '' then
      begin
        Append;
        FieldByName('Filler').Value := Trim(DName);
        FieldByName('status').Value := '0';
      end
      else
      begin
        Edit;
        FieldByName('Editer').Value := Trim(DName);
        FieldByName('EditTime').Value := SGetServerDateTime(ADOTemp);
      end;
      FieldByName('ConMId').Value := Trim(maxno);
      RTSetsavedata(ADOCmd, 'CP_Contract_Main', ScrollBox1, 2);
//      ShowMessage(self.BuyName.Properties.LookupItems[0]+'hh');
//      ShowMessage(self.Sellname.Properties.LookupItems[0]+'hh');
//      ShowMessage(self.MiddleName.Properties.LookupItems.Text+'hh');
//      if Trim(BuyName.Properties.LookupItems.text) = '' then
//      begin
//        FieldByName('BuyNo').Value := Trim(BuyName.Properties.LookupItems[0]);
//      end
//      else
//      begin
//        FieldByName('BuyNo').Value := Trim(BuyName.Properties.LookupItems[0]);
//      end;

      Post;
    end;
    with ADOCmd do
    begin
      Close;
      sql.Clear;
      sql.Add('select * from CP_Contract_Main where ConNo=''' + Trim(ConNo.Text) + '''');
      Open;
    end;
    if ADOCmd.RecordCount > 1 then
      raise Exception.Create('合同号重复！');

    FConMId := Trim(maxno);
////////////////       保存主表          //////////////////////
///
////////////////       保存子表          //////////////////////
    with Order_Sub do
    begin
      First;
      while not Eof do
      begin
        maxno := Trim(Order_Sub.fieldbyname('ConSId').AsString);
        with ADOCmd do
        begin
          Close;
          SQL.Clear;
          sql.Add('select * from CP_Contract_Sub where   ConSId=''' + Trim(maxno) + '''');
          Open;
        end;
        with ADOCmd do
        begin
          if ADOCmd.IsEmpty then
            Append
          else
            Edit;
          RTSetSaveDataCDS(ADOCmd, Tv1, Order_Sub, 'CP_Contract_Sub', 0);
          FieldByName('ConMId').Value := Trim(FConMId);
          FieldByName('ConSId').Value := Trim(maxno);

          Post;
        end;
        with Order_Sub do
        begin
          Edit;
          FieldByName('ConSId').Value := Trim(maxno);
          Post;
        end;
        Next;
      end;
    end;
////////////////       保存子表          //////////////////////
///
////////////////       更新合同          //////////////////////
//    with ADOCmd do
//    begin
//      close;
//      sql.Clear;
//      sql.Add('EXEC  P_Con_Up_PiQty   ');
//      sql.Add('@DataID=' + quotedstr(Trim(FConMId)));
//      execsql;
//    end;
////////////////       更新合同          //////////////////////

    ADOCmd.Connection.CommitTrans;
    Result := True;
  except

    ADOCmd.Connection.RollbackTrans;

    application.MessageBox(PChar(Exception(ExceptObject).Message), '提示信息', 0);

    Result := False;
  end;
end;

end.

